<template>
  <div class="app-container">
    <!-- <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="所属企业ID" prop="companyId">
        <el-input
                v-model="queryParams.companyId"
                placeholder="请输入所属企业ID"
                clearable
                @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>-->

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          >修改</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          >删除</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          >导出
        </el-button>
      </el-col>
      <right-toolbar
        v-model:showSearch="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="videoList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="数据源标题" align="center" prop="title">
        <template #default="scope">
          {{ scope.row.dataSource.title }}
        </template>
      </el-table-column>
      <el-table-column label="封面" align="center">
        <template #default="scope">
          <!-- <QImgPreview :src="getImageSource(videoList)" /> -->
          <QImgPreview :src="scope.row.coverUrl" />
        </template>
      </el-table-column>
      <el-table-column label="视频文件存储路径" align="center" prop="url" />
      <el-table-column label="视频文件类型" align="center" prop="type">
        <template #default="scope">
          <span>{{ typeDictionary[scope.row.type] }}</span>
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template #default="scope">
          <el-button
            link
            type="primary"
            icon="Edit"
            @click="handleUpdate(scope.row)"
            >修改</el-button
          >
          <el-button
            link
            type="primary"
            icon="Delete"
            @click="handleDelete(scope.row)"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改videoData对话框 -->
    <el-dialog :title="title" v-model="open" width="500px" append-to-body>
      <el-form ref="videoRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="数据源ID" prop="dataSourceId">
          <el-input v-model="form.dataSourceId" placeholder="请输入数据源ID" />
        </el-form-item>
        <el-form-item label="视频封面图" prop="coverUrl">
          <QImgUpload v-model="form.coverUrl" placeholder="请输入视频封面图" />
        </el-form-item>
        <el-form-item label="视频文件存储路径" prop="url">
          <el-input v-model="form.url" placeholder="请输入视频文件存储路径" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Video">
import {
  listVideo,
  getVideo,
  delVideo,
  addVideo,
  updateVideo,
} from '@/api/VRdemo/video'

const { proxy } = getCurrentInstance()

const videoList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref('')

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    companyId: null,
    dataSourceId: null,
    dataTypeId: null,
    storageId: null,
    size: null,
    path: null,
    url: null,
    cover: null,
    type: null,
  },
  rules: {
    companyId: [
      { required: true, message: '所属企业ID不能为空', trigger: 'blur' },
    ],
    dataSourceId: [
      { required: true, message: '数据源ID不能为空', trigger: 'blur' },
    ],
    size: [
      { required: true, message: '视频文件大小不能为空', trigger: 'blur' },
    ],
    path: [
      { required: true, message: '视频文件存储路径不能为空', trigger: 'blur' },
    ],
    url: [{ required: true, message: '视频访问URL不能为空', trigger: 'blur' }],
    cover: [
      { required: true, message: '视频封面图URL不能为空', trigger: 'blur' },
    ],
    type: [
      {
        required: true,
        message: '视频文件类型(0 mp4 1 avi 2 wmv 3 mov 4 flv)不能为空',
        trigger: 'change',
      },
    ],
    createTime: [
      { required: true, message: '视频上传时间不能为空', trigger: 'blur' },
    ],
    updateTime: [
      { required: true, message: '视频更新时间不能为空', trigger: 'blur' },
    ],
  },
})

const typeDictionary = {
  0: 'mp4',
  1: 'avi',
  2: 'wmv',
  3: 'mov',
  4: 'flv',
}

const { queryParams, form, rules } = toRefs(data)

/** 查询videoData列表 */
function getList() {
  loading.value = true
  listVideo(queryParams.value).then((response) => {
    videoList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

/** 获取所有spot数据 */
function getSpotList() {
  loading.value = true
  listSpot(queryParams.value).then((response) => {
    spotList.value = response.rows
    total.value = response.total
    loading.value = false
  })
}

// 取消按钮
function cancel() {
  open.value = false
  openSpot.value = false
  openImg.value = false
  openVideo.value = false
  reset()
  getList()
  getSpotList()
}
// 表单重置
function reset() {
  form.value = {
    videoDataId: null,
    companyId: null,
    dataSourceId: null,
    storageId: null,
    size: null,
    path: null,
    url: null,
    cover: null,
    type: null,
    createTime: null,
    updateTime: null,
  }
  proxy.resetForm('videoRef')
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

function viewImage(src) {}
/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm('queryRef')
  handleQuery()
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map((item) => item.videoDataId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 新增按钮操作 */
function handleAdd() {
  reset()
  open.value = true
  title.value = '添加videoData'
}

const getImageSource = computed(() => (row) => {
  if (row.dataTypeId === 3) {
    return row.imgPath
  } else if (row.dataTypeId === 4) {
    return row.cover
  }
  return '' // 返回空字符串或其他默认值
})

/** 修改按钮操作 */
function handleUpdate(row) {
  reset()
  const _videoDataId = row.videoDataId || ids.value
  getVideo(_videoDataId).then((response) => {
    form.value = response.data
    open.value = true
    title.value = '修改videoData'
  })
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs['videoRef'].validate((valid) => {
    if (valid) {
      if (form.value.videoDataId != null) {
        updateVideo(form.value).then((response) => {
          proxy.$modal.msgSuccess('修改成功')
          open.value = false
          getList()
        })
      } else {
        addVideo(form.value).then((response) => {
          proxy.$modal.msgSuccess('新增成功')
          open.value = false
          getList()
        })
      }
    }
  })
}
// 提交视频按钮
function submitVideo() {
  addVideo(formVideo.value).then((response) => {
    proxy.$modal.msgSuccess('操作成功')
    openVideo.value = false
    getList()
    getSpotList()
  })
}
/** 删除按钮操作 */
function handleDelete(row) {
  const _videoDataIds = row.videoDataId || ids.value
  proxy.$modal
    .confirm('是否确认删除videoData编号为"' + _videoDataIds + '"的数据项？')
    .then(function () {
      return delVideo(_videoDataIds)
    })
    .then(() => {
      getList()
      proxy.$modal.msgSuccess('删除成功')
    })
    .catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download(
    'videoData/video/export',
    {
      ...queryParams.value,
    },
    `video_${new Date().getTime()}.xlsx`
  )
}

getList()
</script>
